<script lang="ts">
  import { Color, getColor, getTileEmoji } from "../util";

  export let tile: ColoredTile;

  $: color = getColor(tile);
  $: colorClass = getColorClass(color);

  function getColorClass(color: Color): string {
    switch (color) {
      case Color.Blue:
        return "tile-blue";
      case Color.Red:
        return "tile-red";
      case Color.Yellow:
        return "tile-yellow";
      case Color.Black:
        return "tile-black";
      case Color.White:
        return "tile-white";
    }
  }
</script>

<div class="tile {colorClass}">
  <div class="emoji-wrapper">
    <div class="emoji">{getTileEmoji(color)}</div>
  </div>
</div>

<style>
  .tile {
    --tile-size: 1.25em;
    position: relative;

    height: var(--tile-size);
    width: var(--tile-size);

    border: 1px solid #0003;
    border-radius: 0.2em;
    transform: translate(-1px, -1px);

    filter: drop-shadow(0.1em 0.1em 0.05em #0009);
  }
  .emoji-wrapper {
    height: 100%;
  }

  .tile-blue {
    background-color: #4ec1f5;
  }
  .tile-red {
    background-color: #ec3c3c;
  }
  .tile-yellow {
    background-color: #ffca09;
  }
  .tile-black {
    background-color: hsl(197deg 38% 25%);
  }
  .tile-white {
    background-color: white;
  }
  .tile-white .emoji {
    filter: brightness(1.2) saturate(0);
  }

  .emoji-wrapper {
    filter: drop-shadow(0 0 0.033em #000a);
  }
  .emoji {
    font-size: 75%;
    position: absolute;
    left: 50%;
    top: 50%;
    transform: translate(-50%, -50%) translateY(0.033em);
  }
</style>
